Attribute VB_Name = "modStringToBit06"
Option Explicit

' by Paul - wpsjr1@syix.com
' http://www.syix.com/wpsjr1/index.html

Private lookup(0 To 255) As Currency

Public Function StringToBit06(ByRef sData As String) As String
' by Paul, wpsjr1@syix.com, 20011029
  Dim lLen                As Long
  Dim i                   As Long
  Dim lTemp               As Long
  Static lOutArrayPointer As Long
  Static b()              As Byte
  Static cOut()           As Currency
  Static lInit            As Long
  Static lLastLen         As Long
  Static lpsaOut          As Long
  Static saOut            As SAFEARRAYHEADER
   
  lLen = Len(sData)
  If lLen Then
    If lInit Then
    Else
      lInit = 1
      InitLookupTable
      lOutArrayPointer = VarPtrArray(cOut)
      With saOut
       .DataSize = 8 ' currency array
       .dimensions = 1
      End With
      lpsaOut = VarPtr(saOut)
    End If

    If lLastLen <> lLen Then ReDim b(lLen)
    lLastLen = lLen
    
    FastString.WideCharToMultiByte 0&, 0&, sData, lLen, b(0), lLen, 0&, 0&
    
    StringToBit06 = FastString.SysAllocStringLen(ByVal 0&, lLen * 8)
    With saOut
     .dataPointer = StrPtr(StringToBit06)
     .sab(0).cElements = lLen * 2
    End With
    RtlMoveMemory ByVal lOutArrayPointer, lpsaOut, 4

    Do
      lLen = lLen - 1
      lTemp = b(lLen)
      cOut((lLen * 2) + 1) = lookup(lTemp And &HF)
      cOut(lLen * 2) = lookup(lTemp \ &H10)
    Loop While lLen
    
    RtlMoveMemory ByVal lOutArrayPointer, 0&, 4
  End If
End Function

Public Function StringToBitB06(ByRef sData As String) As String
' by Paul, wpsjr1@syix.com, 20011029
  Dim lLen             As Long
  Dim iTemp            As Integer
  Dim lCounter         As Long
  Static lpsaIn        As Long
  Static lpsaOut       As Long
  Static cOut()        As Currency
  Static iData()       As Integer           ' array shell used to contain string data
  Static saIn          As SAFEARRAYHEADER
  Static saOut         As SAFEARRAYHEADER
  Static lInit         As Long
  Static lInArrayPointer  As Long
  Static lOutArrayPointer As Long
  
  lLen = Len(sData)
      If lInit Then
      Else
        lInit = 1
        InitLookupTable
        lInArrayPointer = VarPtrArray(iData)
        lOutArrayPointer = VarPtrArray(cOut)
        With saIn
          .DataSize = 2  ' integer array
          .dimensions = 1
        End With
        With saOut
          .DataSize = 8 ' currency array
          .dimensions = 1
        End With
        lpsaIn = VarPtr(saIn)
        lpsaOut = VarPtr(saOut)
      End If
      
      With saIn
        .dataPointer = StrPtr(sData)
        .sab(0).cElements = lLen
      End With
      RtlMoveMemory ByVal lInArrayPointer, lpsaIn, 4
      
      StringToBitB06 = FastString.SysAllocStringLen(ByVal 0&, lLen * 8)
      With saOut
        .dataPointer = StrPtr(StringToBitB06)
        .sab(0).cElements = lLen * 2
      End With
      RtlMoveMemory ByVal lOutArrayPointer, lpsaOut, 4

      If lLen Then ' not zero length
        Do
          lLen = lLen - 1
          iTemp = iData(lLen)
          cOut((lLen * 2) + 1) = lookup(iTemp And &HF)
          cOut(lLen * 2) = lookup(iTemp And &HF0)
        Loop While lLen
      End If

    RtlMoveMemory ByVal lInArrayPointer, 0&, 4
    RtlMoveMemory ByVal lOutArrayPointer, 0&, 4
End Function

Public Function StringToBitW06(ByRef sData As String) As String
' by Paul, wpsjr1@syix.com, 20011029
  Dim lLen             As Long
  Dim lTemp            As Long
  Static saIn          As SAFEARRAYHEADER
  Static saOut         As SAFEARRAYHEADER
  Static iData()       As Integer           ' array shell used to contain string data
  Static cOut()        As Currency
  Static lInit         As Long
  Static lpsaIn        As Long
  Static lpsaOut       As Long
  Static lInArrayPointer  As Long
  Static lOutArrayPointer As Long
  
  lLen = Len(sData)
      If lInit Then
      Else
        lInit = 1
        lInArrayPointer = VarPtrArray(iData)
        lOutArrayPointer = VarPtrArray(cOut)
        InitLookupTable
        With saIn
          .DataSize = 2  ' integer array
          .dimensions = 1
        End With
        With saOut
          .DataSize = 8 ' currency array
          .dimensions = 1
        End With
        lpsaIn = VarPtr(saIn)
        lpsaOut = VarPtr(saOut)
      End If
      
      With saIn
        .dataPointer = StrPtr(sData)
        .sab(0).cElements = lLen
      End With
      RtlMoveMemory ByVal lInArrayPointer, lpsaIn, 4
      
      StringToBitW06 = FastString.SysAllocStringLen(ByVal 0&, lLen * 16)
      With saOut
        .dataPointer = StrPtr(StringToBitW06)
        .sab(0).cElements = lLen * 4
      End With
      RtlMoveMemory ByVal lOutArrayPointer, lpsaOut, 4
     
      If lLen Then
        Do
          lLen = lLen - 1
          lTemp = iData(lLen)
          cOut((lLen * 4) + 3) = lookup(lTemp And &HF)
          cOut((lLen * 4) + 2) = lookup(lTemp And &HF0)
          cOut((lLen * 4) + 1) = lookup(lTemp \ &H100 And &HF)
          cOut(lLen * 4) = lookup(lTemp \ &H1000)
        Loop While lLen
      End If
      
      RtlMoveMemory ByVal lInArrayPointer, 0&, 4
      RtlMoveMemory ByVal lOutArrayPointer, 0&, 4
End Function


Private Sub InitLookupTable()
  Dim i As Long

  lookup(0) = 1351100504368.7472@ ' magic numbers, magical mystery tour :P
  lookup(1) = 1379248002039.8128@
  lookup(2) = 1351100933865.4768@
  lookup(3) = 1379248431536.5424@
  lookup(4) = 1351100504375.3008@
  lookup(5) = 1379248002046.3664@
  lookup(6) = 1351100933872.0304@
  lookup(7) = 1379248431543.096@
  lookup(8) = 1351100504368.7473@
  lookup(9) = 1379248002039.8129@
  lookup(10) = 1351100933865.4769@
  lookup(11) = 1379248431536.5425@
  lookup(12) = 1351100504375.3009@
  lookup(13) = 1379248002046.3665@
  lookup(14) = 1351100933872.0305@
  lookup(15) = 1379248431543.0961@
  
  For i = 16 To 255
    lookup(i) = lookup((i And &HF0) \ &H10)
  Next i
End Sub
